Index: examples/wscript_build
===================================================================
--- examples/wscript_build	(revision cbc9765223848233d3235557c10be0066556118f)
+++ examples/wscript_build	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
@@ -2,18 +2,18 @@
 
 # build examples
-utilsio = ctx.new_task_gen(name = 'utilsio', features = 'c',
-      includes = '../src',
-      source = ['utils.c', 'jackio.c'],
-      uselib = ['LASH', 'JACK'],
-      target = 'utilsio')
+utilsio = bld(
+        name = 'utilsio',
+        features = 'c',
+        includes = '../src',
+        source = ['utils.c', 'jackio.c'],
+        uselib = ['LASH', 'JACK'],
+        target = 'utilsio')
 
 # loop over all *.c filenames in examples to build them all
-for target_name in ctx.path.ant_glob('*.c', excl = ['utils.c', 'jackio.c']):
-  ctx.new_task_gen(features = 'c cprogram',
-      add_objects = 'utilsio',
+for source_file in ctx.path.ant_glob('*.c', excl = ['utils.c', 'jackio.c']):
+  bld.program(features = 'c cprogram',
       includes = '../src',
-      uselib = ['LASH', 'JACK', 'SNDFILE'],
-      use = 'aubio',
-      source = target_name,
-      # program name is filename.c without the .c
-      target = str(target_name).split('.')[0])
+      use = ['aubio', 'LASH', 'JACK', 'SNDFILE', 'utilsio'],
+      source = str(source_file),
+      target = str(source_file).split('.')[0]
+    )
Index: src/wscript_build
===================================================================
--- src/wscript_build	(revision cbc9765223848233d3235557c10be0066556118f)
+++ src/wscript_build	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
@@ -25,5 +25,5 @@
 # install headers, except _priv.h ones
 ctx.install_files('${PREFIX}/include/aubio/',
-	ctx.path.ant_glob('**/*.h',
-	exclude = ['_priv.h', 'config.h']),
-	relative_trick=True)
+
+    ctx.path.ant_glob('**/*.h', excl = ['**_priv.h', 'config.h']),
+    relative_trick=True)
Index: tests/wscript_build
===================================================================
--- tests/wscript_build	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
+++ tests/wscript_build	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
@@ -0,0 +1,21 @@
+# vim:set syntax=python:
+
+for target_name in ctx.path.ant_glob('src/**/*.c'):
+  uselib = []
+  includes = ['../src']
+  extra_source = []
+  if str(target_name).endswith('-jack.c') and ctx.env['JACK']:
+    uselib += ['JACK']
+    includes += ['../examples']
+    extra_source += ['../examples/jackio.c']
+
+  bld(features = 'c cprogram test',
+      uselib = uselib,
+      source = [target_name] + extra_source,
+      target = str(target_name).split('.')[0],
+      includes = includes,
+      install_path = None,
+      defines = 'AUBIO_UNSTABLE_API=1',
+      cflags = ['-g'],
+      use = 'aubio')
+
Index: waf
===================================================================
--- waf	(revision cbc9765223848233d3235557c10be0066556118f)
+++ waf	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
@@ -1,5 +1,5 @@
 #!/usr/bin/env python
 # encoding: ISO8859-1
-# Thomas Nagy, 2005-2011
+# Thomas Nagy, 2005-2012
 
 """
@@ -33,8 +33,8 @@
 import os, sys
 
-VERSION="1.6.11"
-REVISION="9ba72a99056a2dfa53f17212aa3b8606"
+VERSION="1.7.9"
+REVISION="b503f38d25464d88953a601c8cd0ace6"
 INSTALL=''
-C1='#2'
+C1='#='
 C2='#+'
 cwd = os.getcwd()
@@ -75,11 +75,11 @@
 			os.makedirs(join(dir, 'waflib', x))
 	except OSError:
-		err("Cannot unpack waf lib into %s\nMove waf into a writeable directory" % dir)
+		err("Cannot unpack waf lib into %s\nMove waf in a writable directory" % dir)
 
 	os.chdir(dir)
 	tmp = 't.bz2'
 	t = open(tmp,'wb')
-	t.write(txt)
-	t.close()
+	try: t.write(txt)
+	finally: t.close()
 
 	try:
@@ -96,6 +96,8 @@
 			err("Waf cannot be unpacked, check that bzip2 support is present")
 
-	for x in t: t.extract(x)
-	t.close()
+	try:
+		for x in t: t.extract(x)
+	finally:
+		t.close()
 
 	for x in ['Tools', 'extras']:
Index: wscript
===================================================================
--- wscript	(revision cbc9765223848233d3235557c10be0066556118f)
+++ wscript	(revision 6ed0f4ee598ff53b9223e916c5a6e1ba4ec17f31)
@@ -53,11 +53,9 @@
       help='set target platform for cross-compilation', dest='target_platform')
   ctx.load('compiler_c')
-  ctx.load('gnu_dirs')
   ctx.load('waf_unit_test')
 
 def configure(ctx):
-  import Options
-  ctx.check_tool('compiler_c')
-  ctx.check_tool('gnu_dirs') # helpful for autotools transition and .pc generation
+  from waflib import Options
+  ctx.load('compiler_c')
   ctx.load('waf_unit_test')
   ctx.env.CFLAGS = ['-g', '-Wall', '-Wextra']
@@ -180,14 +178,12 @@
     ctx.to_log('docbook-to-man was not found (ignoring)')
 
-def build(ctx):
-  ctx.env['VERSION'] = VERSION
-  ctx.env['LIB_VERSION'] = LIB_VERSION
+def build(bld):
+  bld.env['VERSION'] = VERSION
+  bld.env['LIB_VERSION'] = LIB_VERSION
 
   # add sub directories
-  ctx.add_subdirs(['src','examples'])
-  if ctx.env['SWIG']:
-    if ctx.env['PYTHON']:
-      ctx.add_subdirs('python')
-
+  bld.recurse('src examples tests')
+
+  """
   # create the aubio.pc file for pkg-config
   if ctx.env['TARGET_PLATFORM'] == 'linux':
@@ -212,32 +208,5 @@
 
   # install woodblock sound
-  ctx.install_files('${PREFIX}/share/sounds/aubio/',
+  bld.install_files('${PREFIX}/share/sounds/aubio/',
       'sounds/woodblock.aiff')
-
-  # build and run the unit tests
-  build_tests(ctx)
-
-def shutdown(ctx):
-  pass
-
-# loop over all *.c filenames in tests/src to build them all
-# target name is filename.c without the .c
-def build_tests(ctx):
-  for target_name in ctx.path.ant_glob('tests/src/**/*.c'):
-    uselib = []
-    includes = ['src']
-    extra_source = []
-    if str(target_name).endswith('-jack.c') and ctx.env['JACK']:
-      uselib += ['JACK']
-      includes += ['examples']
-      extra_source += ['examples/jackio.c']
-
-    this_target = ctx.new_task_gen(
-        features = 'c cprogram test',
-        uselib = uselib,
-        source = [target_name] + extra_source,
-        target = str(target_name).split('.')[0],
-        includes = includes,
-        defines = 'AUBIO_UNSTABLE_API=1',
-        cflags = ['-g'],
-        use = 'aubio')
+  """
